unit BitmapProg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls;

type
  TBitmapProgress = class(TForm)
    ProgressBar: TProgressBar;
  private
    { Private declarations }
  public
  procedure HandleObjectProgress(Sender: TObject; Stage: TProgressStage; PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: string);
  end;

var
  BitmapProgress: TBitmapProgress;

procedure HandleProgress(Sender: TObject; Stage: TProgressStage; PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: string);
procedure DisplayProgress; overload;
procedure DisplayProgress(Title: string); overload;
procedure DoProgress(Percent: integer);

procedure HideProgress;

implementation

{$R *.DFM}


{Note: The reason some of these routines are similar is that they work for
different components and libraies}


procedure ResetProgress;
begin
BitmapProgress.ProgressBar.Min:=0;
BitmapProgress.ProgressBar.Max:=100;
BitmapProgress.ProgressBar.Position:=0
end;



procedure DisplayProgress(Title: string);
begin
BitmapProgress:=TBitmapProgress.Create(nil);
BitmapProgress.Caption:=Title;
BitmapProgress.Show;
ResetProgress;
BitmapProgress.ProgressBar.Update;
end;



procedure DisplayProgress;
begin
DisplayProgress('Loading Bitmap');
end;


procedure HideProgress;
begin
BitmapProgress.Hide;
BitmapProgress.Free;
end;


procedure HandleProgress(Sender: TObject; Stage: TProgressStage; PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: string);
{Progress for bitmap display}
begin
case Stage of
 psStarting: ResetProgress;
 psRunning: BitmapProgress.ProgressBar.Position:=PercentDone;
 psEnding: ;
 end;
BitmapProgress.ProgressBar.Update;
end;




procedure DoProgress(Percent: integer);
{Progress for bitmap resixing}
begin
BitmapProgress.ProgressBar.Position:=Percent;
BitmapProgress.ProgressBar.Update;
end;


procedure TBitmapProgress.HandleObjectProgress(Sender: TObject; Stage: TProgressStage; PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: string);
begin
HandleProgress(Sender,Stage,PercentDone,RedrawNow,R,Msg);
end;


end.
