unit ComLibrary;

interface

uses Windows,SysUtils,Controls,Dialogs,StdCtrls,Variants,ComObj,ActiveX,DSupport;


function VarToInterface(const V: Variant): IDispatch;
function IsImplemented(const Instance: Variant; MethodName: WideString): boolean;
function GetMemberValue(const Instance: Variant; MemberName: WideString): OleVariant;
function GetMemberString(const Instance: Variant; MemberName: WideString): string;

function GetMemberFloat(const Instance: Variant; MemberName: WideString; Digits: integer): string;
function GetMemberBoolean(const Instance: Variant; MemberName: WideString): Boolean;

implementation


function VarToInterface(const V: Variant): IDispatch;
begin
Result := nil;
if TVarData(V).VType = varDispatch then Result := IDispatch(TVarData(V).VDispatch)
else if TVarData(V).VType = (varDispatch or varByRef) then Result := IDispatch(TVarData(V).VPointer^);
end;



function IsImplemented(const Instance: Variant; MethodName: WideString): boolean;
{Check an Automation Object varible to see if one of its methods/properties has been implmented}
var Dispatch: IDispatch;
var Temp: integer;
var ID: integer;
begin
Dispatch:=VarToInterface(Instance);
Temp := Dispatch.GetIDsOfNames(GUID_NULL, @MethodName, 1, LOCALE_USER_DEFAULT, @ID);
Result:= Temp<>Integer(DISP_E_UNKNOWNNAME);
end;



function GetMemberValue(const Instance: Variant; MemberName: WideString): OleVariant;
{Check if member is implements and return its value if it is}
var Dispatch: IDispatch;
var Temp: integer;
var ID: integer;
begin
Dispatch:=VarToInterface(Instance);
Temp := Dispatch.GetIDsOfNames(GUID_NULL, @MemberName, 1, LOCALE_USER_DEFAULT, @ID);
if Temp<>Integer(DISP_E_UNKNOWNNAME) then Result:=GetDispatchPropValue(Dispatch, ID)
else Result:=Null;
end;



function GetMemberBoolean(const Instance: Variant; MemberName: WideString): Boolean;
{Check if member is implements and return its value if it is}
var Dispatch: IDispatch;
var Temp: integer;
var ID: integer;
begin
Dispatch:=VarToInterface(Instance);
Temp := Dispatch.GetIDsOfNames(GUID_NULL, @MemberName, 1, LOCALE_USER_DEFAULT, @ID);
if Temp<>Integer(DISP_E_UNKNOWNNAME) then Result:=GetDispatchPropValue(Dispatch, ID)
else Result:=False;
end;


function GetMemberString(const Instance: Variant; MemberName: WideString): string;
var OV: OleVariant;
begin
if IsImplemented(Instance,MemberName) then
	begin
	OV:=GetMemberValue(Instance,MemberName);
	if not VarIsNull(OV) then Result:=OV else Result:='NA';
	end
else Result:='NA';
end;


function GetMemberFloat(const Instance: Variant; MemberName: WideString; Digits: integer): string;
var OV: OleVariant;
begin
if IsImplemented(Instance,MemberName) then
	begin
	OV:=GetMemberValue(Instance,MemberName);
	if not VarIsNull(OV) then Result:=FloatToStrF(OV,ffFixed,18,Digits) else Result:='NA';
	end
else Result:='NA';
end;




end.
