unit Harmonizer;

interface

uses SysUtils;

{Control to handle difference between different versin of Delphi}

type TDayStrings = array[1..7] of string;
type TMonthStrings = array[1..12] of string;

type TIndeSystemData = class(TObject)
  private
    function GetCurrencyDecimals: Byte;
    function GetCurrencyFormat: Byte;
    function GetCurrencyString: string;
    function GetDateSeparator: Char;
    function GetDecimalSeparator: Char;
    function GetListSeparator: Char;
    function GetLongDateFormat: string;
    function GetLongDayNames: TDayStrings;
    function GetLongMonthNames: TMonthStrings;
    function GetLongTimeFormat: string;
    function GetNegCurrFormat: Byte;
    function GetShortDateFormat: string;
    function GetShortDayNames: TDayStrings;
    function GetShortMonthNames: TMonthStrings;
    function GetShortTimeFormat: string;
    function GetThousandSeparator: Char;
    function GetTimeAMString: string;
    function GetTimePMString: string;
    function GetTimeSeparator: Char;
    function GetTwoDigitYearCenturyWindow: Word;
    procedure SetCurrencyDecimals(const Value: Byte);
    procedure SetCurrencyFormat(const Value: Byte);
    procedure SetCurrencyString(const Value: string);
    procedure SetDateSeparator(const Value: Char);
    procedure SetDecimalSeparator(const Value: Char);
    procedure SetListSeparator(const Value: Char);
    procedure SetLongDateFormat(const Value: string);
    procedure SetLongDayNames(const Value: TDayStrings);
    procedure SetLongMonthNames(const Value: TMonthStrings);
    procedure SetLongTimeFormat(const Value: string);
    procedure SetNegCurrFormat(const Value: Byte);
    procedure SetShortDateFormat(const Value: string);
    procedure SetShortDayNames(const Value: TDayStrings);
    procedure SetShortMonthNames(const Value: TMonthStrings);
    procedure SetShortTimeFormat(const Value: string);
    procedure SetThousandSeparator(const Value: Char);
    procedure SetTimeAMString(const Value: string);
    procedure SetTimePMString(const Value: string);
    procedure SetTimeSeparator(const Value: Char);
    procedure SetTwoDigitYearCenturyWindow(const Value: Word);
    function GetSysLocale: TSysLocale;
    procedure SetSysLocale(const Value: TSysLocale);
 public
  constructor Create;
  property CurrencyString: string read GetCurrencyString write SetCurrencyString;
  property CurrencyFormat: Byte read GetCurrencyFormat write SetCurrencyFormat;
  property CurrencyDecimals: Byte read GetCurrencyDecimals write SetCurrencyDecimals;
  property DateSeparator: Char read GetDateSeparator write SetDateSeparator;
  property TimeSeparator: Char read GetTimeSeparator write SetTimeSeparator;
  property ListSeparator: Char read GetListSeparator write SetListSeparator;
  property ShortDateFormat: string read GetShortDateFormat write SetShortDateFormat;
  property LongDateFormat: string read GetLongDateFormat write SetLongDateFormat;
  property TimeAMString: string read GetTimeAMString write SetTimeAMString;
  property TimePMString: string read GetTimePMString write SetTimePMString;
  property ShortTimeFormat: string read GetShortTimeFormat write SetShortTimeFormat;
  property LongTimeFormat: string read GetLongTimeFormat write SetLongTimeFormat;
  property ShortMonthNames: TMonthStrings read GetShortMonthNames write SetShortMonthNames;
  property LongMonthNames: TMonthStrings read GetLongMonthNames write SetLongMonthNames;
  property ShortDayNames: TDayStrings read GetShortDayNames write SetShortDayNames;
  property LongDayNames: TDayStrings read GetLongDayNames write SetLongDayNames;
  property ThousandSeparator: Char read GetThousandSeparator write SetThousandSeparator;
  property DecimalSeparator: Char read GetDecimalSeparator write SetDecimalSeparator;
  property TwoDigitYearCenturyWindow: Word read GetTwoDigitYearCenturyWindow write SetTwoDigitYearCenturyWindow;
  property NegCurrFormat: Byte read GetNegCurrFormat write SetNegCurrFormat;
  property SysLocale: TSysLocale read GetSysLocale write SetSysLocale;
 end;

var IndSystemData: TIndeSystemData;

implementation



{ TSystemHarmonizer }

constructor TIndeSystemData.Create;
begin
inherited Create;
end;

function TIndeSystemData.GetCurrencyString: string;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND} .CurrencyString;
end;

function TIndeSystemData.GetCurrencyFormat: Byte;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.CurrencyFormat;

end;

function TIndeSystemData.GetCurrencyDecimals: Byte;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.CurrencyDecimals;

end;


function TIndeSystemData.GetDateSeparator: Char;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.DateSeparator;
end;

function TIndeSystemData.GetDecimalSeparator: Char;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.DecimalSeparator;

end;

function TIndeSystemData.GetListSeparator: Char;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ListSeparator;
end;

function TIndeSystemData.GetLongDateFormat: string;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongDateFormat;

end;

function TIndeSystemData.GetLongDayNames: TDayStrings;
var I: integer;
begin
for I:=0 to High({$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongDayNames) do
 Result[I]:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongDayNames[I];

end;

function TIndeSystemData.GetLongMonthNames: TMonthStrings;
var I: integer;
begin
for I:=0 to High({$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongMonthNames) do
 Result[I]:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongMonthNames[I];

end;

function TIndeSystemData.GetLongTimeFormat: string;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongTimeFormat;

end;

function TIndeSystemData.GetNegCurrFormat: Byte;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.NegCurrFormat;

end;

function TIndeSystemData.GetShortDateFormat: string;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortDateFormat;

end;

function TIndeSystemData.GetShortDayNames: TDayStrings;
var I: integer;
begin
for I:=0 to High({$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortDayNames) do
 Result[I]:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortDayNames[I];

end;

function TIndeSystemData.GetShortMonthNames: TMonthStrings;
var I: integer;
begin
for I:=0 to High({$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortMonthNames) do
 Result[I]:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortMonthNames[I];

end;

function TIndeSystemData.GetShortTimeFormat: string;

begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortTimeFormat;
end;

function TIndeSystemData.GetThousandSeparator: Char;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ThousandSeparator;
end;

function TIndeSystemData.GetTimeAMString: string;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.TimeAMString;

end;

function TIndeSystemData.GetTimePMString: string;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.TimePMString;

end;

function TIndeSystemData.GetTimeSeparator: Char;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.TimeSeparator;

end;


function TIndeSystemData.GetSysLocale: TSysLocale;
begin
Result:=SysUtils.SysLocale;
end;

function TIndeSystemData.GetTwoDigitYearCenturyWindow: Word;
begin
Result:={$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.TwoDigitYearCenturyWindow;

end;


{------------------------------------------------------------------------------}


procedure TIndeSystemData.SetCurrencyDecimals(const Value: Byte);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.CurrencyDecimals:=Value;
end;

procedure TIndeSystemData.SetCurrencyFormat(const Value: Byte);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.CurrencyFormat:=Value;
end;

procedure TIndeSystemData.SetCurrencyString(const Value: string);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.CurrencyString:=Value;
end;

procedure TIndeSystemData.SetDateSeparator(const Value: Char);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.DateSeparator:=Value;
end;

procedure TIndeSystemData.SetDecimalSeparator(const Value: Char);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.DecimalSeparator:=Value;
end;

procedure TIndeSystemData.SetListSeparator(const Value: Char);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ListSeparator:=Value;
end;

procedure TIndeSystemData.SetLongDateFormat(const Value: string);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongDateFormat:=Value;
end;

procedure TIndeSystemData.SetLongDayNames(const Value: TDayStrings);
var I: integer;
begin
for I:=0 to High(Value) do
	{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongDayNames[I]:=Value[I];
end;

procedure TIndeSystemData.SetLongMonthNames(const Value: TMonthStrings);
var I: integer;
begin
for I:=0 to High(Value) do
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongMonthNames[I]:=Value[I];
end;

procedure TIndeSystemData.SetLongTimeFormat(const Value: string);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.LongTimeFormat:=Value;
end;

procedure TIndeSystemData.SetNegCurrFormat(const Value: Byte);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.NegCurrFormat:=Value;
end;

procedure TIndeSystemData.SetShortDateFormat(const Value: string);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortDateFormat:=Value;
end;

procedure TIndeSystemData.SetShortDayNames(const Value: TDayStrings);
var I: integer;
begin
for I:=0 to High(Value) do
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortDayNames[I]:=Value[I];
end;

procedure TIndeSystemData.SetShortMonthNames(const Value: TMonthStrings);
var I: integer;
begin
for I:=0 to High(Value) do
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortMonthNames[I]:=Value[I];
end;

procedure TIndeSystemData.SetShortTimeFormat(const Value: string);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ShortTimeFormat:=Value;
end;

procedure TIndeSystemData.SetThousandSeparator(const Value: Char);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.ThousandSeparator:=Value;
end;

procedure TIndeSystemData.SetTimeAMString(const Value: string);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.TimeAMString:=Value;
end;

procedure TIndeSystemData.SetTimePMString(const Value: string);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.TimePMString:=Value;
end;

procedure TIndeSystemData.SetTimeSeparator(const Value: Char);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.TimeSeparator:=Value;
end;

procedure TIndeSystemData.SetTwoDigitYearCenturyWindow(const Value: Word);
begin
{$IF CompilerVersion<22} SysUtils {$ELSE} FormatSettings {$IFEND}.TwoDigitYearCenturyWindow:=Value;
end;


procedure TIndeSystemData.SetSysLocale(const Value: TSysLocale);
begin
SysUtils.SysLocale:=Value;
end;

initialization
IndSystemData:=TIndeSystemData.Create;
finalization
IndSystemData.Free;
end.


