unit IEFill;

interface

uses ExtCtrls,Graphics,BitmapLib;


procedure ColorFillOnImage(Start: boolean; X,Y,Size: integer; Threshold: double; C: TColor);
procedure FloodFillOnImage(Start: boolean; X,Y,Size: integer; C: TColor);
function GammaFunction(X: double): double;


implementation

uses ImageEditor, IEPolygonLib, IEClipper;




procedure FloodFill(Image: TImage; X,Y: integer; Color: TColor);
begin
Image.Canvas.Brush.Color:=Color;
Image.Canvas.FloodFill(X,Y,Image.Canvas.Pixels[X,Y],fsSurface);
end;



procedure Progress(Percent: integer);
begin
ImageEditorDlg.ProgressGauge.Progress:=Percent;
end;





function GammaFunction(X: double): double;
const B = 5;
begin
if B=0 then Result:=X
else Result:=(exp(X * B) - 1) * 1/(exp(B)-1);
end;



procedure FloodFillOnImage(Start: boolean; X,Y,Size: integer; C: TColor);
var T: double;
begin
if Start then
	begin
	ImageEditorDlg.Image.RestoreImage;
	ImageEditorDlg.ImageUndoer.StoreUndo;
        end;
T:=ImageEditorDlg.FillThresholdBar.Position/100;
T:=GammaFunction(T);

SeedFloodFill(PolyClipper.InitializeBMPClip(ImageEditorDlg.Image.Picture.Bitmap),X,Y,C,T,Progress);
PolyClipper.DoBMPClip(ImageEditorDlg.Image.Picture.Bitmap);
ImageEditorDlg.Image.Invalidate;
end;




procedure ColorFillOnImage(Start: boolean; X,Y,Size: integer; Threshold: double; C: TColor);
begin
if Start then
	begin
	ImageEditorDlg.Image.RestoreImage;
	ImageEditorDlg.ImageUndoer.StoreUndo;
        end;

ColorFill(PolyClipper.InitializeBMPClip(ImageEditorDlg.Image.Picture.Bitmap),X,Y,Threshold,C);
PolyClipper.DoBMPClip(ImageEditorDlg.Image.Picture.Bitmap);

ImageEditorDlg.Image.Invalidate;
end;


end.
 