unit IEPolygonUndo;

interface

uses Classes,GLPolygons;

procedure UndoLastChange(var PA: TRealPolygonArray);
procedure AddUndoItem(var PA: TRealPolygonArray);
procedure ClearUndoList;

implementation

uses IEPolygonLib;


var UndoList: TList;


procedure ClearUndoList;
var I: integer;
begin
for I:= UndoList.Count-1 downto 0 do
 TRealPolygonArray(UndoList[I]).Free;
end;


procedure DeleteUndoItem(Inx: integer);
begin
if Inx>=UndoList.Count then exit;
TRealPolygonArray(UndoList[Inx]).Free;
UndoList.Delete(Inx);
end;


procedure AddUndoItem(var PA: TRealPolygonArray);
var PA1: TRealPolygonArray;
begin
PA1:=TRealPolygonArray.Create;
PA1.Assign(PA);
UndoList.Add(PA1);
end;




procedure UndoLastChange(var PA: TRealPolygonArray);
var PA1: TRealPolygonArray;
begin
if UndoList.Count<1 then exit;
PA.Assign(TRealPolygonArray(UndoList[UndoList.Count-1]));
DeleteUndoItem(UndoList.Count-1);
if PolygonArray.Count>0 then
	begin
	SelectPoint.PolyInx:=PolygonArray.Count-1;
	SelectPoint.PointInx:=0;
	SelectPoint.Valid:=True;
	end
else
	begin
	SelectPoint.PolyInx:=0;
	SelectPoint.PointInx:=0;
	SelectPoint.Valid:=False;
	end;
end;




initialization
UndoList:=TList.Create;
finalization
ClearUndoList;
UndoList.Free;
end.
