unit IESetSize;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, SpinButtons, intspin,ImageEx,BitmapLib;

type
  TSetSizeDlg = class(TForm)
    CancelBtn: TButton;
    WidthSpin: TIntegerSpin;
    HeightSpin: TIntegerSpin;
    Label1: TLabel;
    Label2: TLabel;
    RatioChk: TCheckBox;
    ResetBtn: TButton;
    ApplyBtn: TButton;
    CenterChk: TCheckBox;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure WidthSpinChange(Sender: TObject);
    procedure HeightSpinChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var SetSizeDlg: TSetSizeDlg;

procedure DoImageResize(Image: TImageEx);

implementation

uses ImageEditor;

{$R *.dfm}

var BM: TBitmap;
var CurrentImage: TImageEx;

var AspectRatio: double;



procedure ResetImageSize;
begin
SetSizeDlg.WidthSpin.NoEventValue:=BM.Width;
SetSizeDlg.HeightSpin.NoEventValue:=BM.Height;
AspectRatio:=BM.Width/BM.Height;
end;


procedure DoImageResize(Image: TImageEx);
begin
Image.RestoreImage;
CurrentImage:=Image;
BM.Assign(Image.Picture.Bitmap);
ResetImageSize;
SetSizeDlg.ShowModal;
end;


procedure TSetSizeDlg.FormCreate(Sender: TObject);
begin
BM:=TBitmap.Create;
end;



procedure TSetSizeDlg.FormDestroy(Sender: TObject);
begin
BM.Free;
end;



procedure TSetSizeDlg.ResetBtnClick(Sender: TObject);
begin
ResetImageSize;
end;



procedure TSetSizeDlg.ApplyBtnClick(Sender: TObject);
var DX,DY: integer;
begin
CurrentImage.Picture.Bitmap.Width:=WidthSpin.Value;
CurrentImage.Picture.Bitmap.Height:=HeightSpin.Value;
DX:=0; DY:=0;
if CenterChk.Checked then
	begin
	DX:=CurrentImage.Picture.Bitmap.Width - BM.Width;
	DY:=CurrentImage.Picture.Bitmap.Height - BM.Height;
	end;
ClearBitmap(CurrentImage.Picture.Bitmap,clWhite);
CurrentImage.Picture.Bitmap.Canvas.Draw(DX div 2,DY div 2,BM);
NormalizeImageSize(CurrentImage);
CurrentImage.Invalidate;
end;




procedure TSetSizeDlg.WidthSpinChange(Sender: TObject);
begin
if RatioChk.Checked then HeightSpin.NoEventValue:=round(WidthSpin.Value/AspectRatio);
end;



procedure TSetSizeDlg.HeightSpinChange(Sender: TObject);
begin
if RatioChk.Checked then WidthSpin.NoEventValue:=round(HeightSpin.Value*AspectRatio);
end;



end.
