unit IEUndoListDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ImageList;

type
  TUndoListDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    ImageListBox1: TImageListBox;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Image1: TImage;
    ShowRadio: TRadioGroup;
    procedure CancelBtnClick(Sender: TObject);
    procedure ImageListBox1Click(Sender: TObject);
    procedure ShowRadioClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  UndoListDlg: TUndoListDlg;

//procedure ShowUndoListDlg;
//procedure ShowUndoItems;
//procedure ShowBackBitmap;

implementation

uses ImageEditor;

{$R *.dfm}



procedure ShowBackBitmap;
begin
if not ImageEditorDlg.Visible then exit;
if UndoListDlg.ShowRadio.ItemIndex<>1 then exit;
UndoListDlg.Image1.Picture.Assign(ImageEditorDlg.Image.SavedImage);
UndoListDlg.Image1.Repaint;
end;



procedure ShowUndoItems;
var Inx,I,LastValid: integer;
var S: string;
var BMP: TBitmap;
begin
if not ImageEditorDlg.Visible then exit;
if UndoListDlg.ShowRadio.ItemIndex<>0 then exit;
with UndoListDlg, ImageEditorDlg do
 begin
 BMP:=TBitmap.Create;
 try
 ImageListBox1.Clear;
 I:=1;
 LastValid:=-1;
 Inx:=ImageUndoer.Undoer.Fileundo.CircularIndex.EnumerateIndices(True);
 while Inx>=0 do
	begin
	S:=ImageUndoer.Undoer.FileUndo.Filename[Inx];
	BMP.LoadFromFile(S);
	ImageListBox1.AddBitmap(BMP,IntToStr(I));
	LastValid:=Inx;
	Inx:=ImageUndoer.Undoer.Fileundo.CircularIndex.EnumerateIndices(False);
	Inc(I);
	end;
 if LastValid>=0 then Image1.Picture.Assign(ImageListBox1.Bitmaps[LastValid]);
 finally BMP.Free; end;
 end;
end;



procedure ShowUndoListDlg;
begin
UndoListDlg.ShowRadioClick(UndoListDlg);
UndoListDlg.Show;
end;



procedure TUndoListDlg.CancelBtnClick(Sender: TObject);
begin
Close;
end;



procedure TUndoListDlg.ImageListBox1Click(Sender: TObject);
var Inx: integer;
begin
Inx:=ImageListBox1.ItemIndex;
Image1.Picture.Assign(ImageListBox1.Bitmaps[Inx]);
end;



procedure TUndoListDlg.ShowRadioClick(Sender: TObject);
begin
case ShowRadio.ItemIndex of
 0: ShowUndoItems;
 1: ShowBackBitmap;
 end;
end;

procedure TUndoListDlg.FormCreate(Sender: TObject);
begin
Panel2.DoubleBuffered:=True;
end;

end.
