unit LinePatternDialog;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, GraphicsLib, SpinButtons, intspin, Grids, VCLLibrary;

type
  TLinePatternDlg = class(TForm)
    Panel1: TPanel;
    PatternGrid: TDrawGrid;
    Label1: TLabel;
    Panel2: TPanel;
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel3: TPanel;
    Label2: TLabel;
    CountSpin: TIntegerSpin;
    GroupBox1: TGroupBox;
    SampleBox: TPaintBox;
    procedure PatternGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure SampleBoxPaint(Sender: TObject);
    procedure CountSpinChange(Sender: TObject);
    procedure PatternGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure PatternGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LinePatternDlg: TLinePatternDlg;

function SetupLinePattern(var Pattern: TPatternArray): boolean;


implementation

{$R *.dfm}


var WrkPattern: TPatternArray;


procedure ShowPattern;
const Border=5;
var R: TRect;
var Y: integer;
begin
with LinePatternDlg do
 begin
 R:=SampleBox.ClientRect;
 SampleBox.Canvas.FillRect(R);
 Y:=(R.Bottom+R.Top) div 2;
 SampleBox.Canvas.Pen.Width:=3;
 SetDashedPen(SampleBox.Canvas,1,WrkPattern);
 SampleBox.Canvas.MoveTo(R.Left+Border,Y);
 SampleBox.Canvas.LineTo(R.Right-Border,Y);
 SampleBox.Canvas.Pen.Style:=psSolid;
 end;
end;




procedure TLinePatternDlg.PatternGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var S: string;
begin
if ARow=0 then
	begin
	case (ACol mod 2) of
	 0: S:='Line-'+IntToStr(ACol div 2+1);
	 1: S:='Space-'+IntToStr(ACol div 2+1);
         end;
	OwnerDrawItem(PatternGrid.Canvas,S,Rect);
	end
else
	begin
	OwnerDrawInteger(PatternGrid.Canvas,WrkPattern[ACol],Rect);
	end;
end;


procedure ConfigureGrid;
begin
LinePatternDlg.PatternGrid.ColCount:=Length(WrkPattern);
end;



procedure TLinePatternDlg.SampleBoxPaint(Sender: TObject);
begin
ShowPattern;
end;


function SetupLinePattern(var Pattern: TPatternArray): boolean;
begin
WrkPattern:=Pattern;
ConfigureGrid;
LinePatternDlg.ShowModal;
Result:=LinePatternDlg.ModalResult=mrOK;
if Result then Pattern:=WrkPattern;
end;


procedure TLinePatternDlg.CountSpinChange(Sender: TObject);
var OldLen: integer;
var I: integer;
begin
OldLen:=Length(WrkPattern);
SetLength(WrkPattern,CountSpin.Value);
for I:=OldLen to High(WrkPattern) do WrkPattern[I]:=1;
ConfigureGrid;
SampleBox.Invalidate;
end;



procedure TLinePatternDlg.PatternGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin
Value:=IntToStr(WrkPattern[ACol]);
end;



procedure TLinePatternDlg.PatternGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
WrkPattern[ACol]:=StrToIntDef(Value,WrkPattern[ACol]);
SampleBox.Invalidate;
end;


end.
