unit FFOptions;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, DSupport, SpinButtons, intspin, ComCtrls, Degspin, ImgList,
  TreeViewEx, CheckBoxExt, Autobttn, Dialogs, Realspin, Grids,VCLLibrary;

type
  TOptionsDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel5: TPanel;
    Panel2: TPanel;
    TimeSpin: TDegreeSpin;
    Panel3: TPanel;
    TabSheet2: TTabSheet;
    ImageList1: TImageList;
    ContextTree: TTreeViewEx;
    Panel27: TPanel;
    Label17: TLabel;
    Panel29: TPanel;
    DeleteMarkBtn: TSpeedButton;
    InsertMarkBtn: TSpeedButton;
    MoveDownBtn: TAutoButton;
    MoveUpBtn: TAutoButton;
    TabSheet3: TTabSheet;
    Panel6: TPanel;
    Panel18: TPanel;
    ShowBtn: TSpeedButton;
    TreeFindSur1Btn: TSpeedButton;
    ExpandBtn: TSpeedButton;
    CollapseBtn: TSpeedButton;
    FindDialog1: TFindDialog;
    MSSpin: TRealSpin;
    MarkList: TDrawGrid;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SaveAsBtn: TSpeedButton;
    QueueDeptDis: TEditEx;
    Panel8: TPanel;
    FilenameDis: TEditEx;
    InfoMemo: TMemo;
    Panel4: TPanel;
    TrackVideoChk: TCheckBox;
    SetBtn: TButton;
    procedure CancelBtnClick(Sender: TObject);
    procedure SetBtnClick(Sender: TObject);
    procedure TimeSpinChange(Sender: TObject);
    procedure MSSpinChange(Sender: TObject);
    procedure ShowBtnClick(Sender: TObject);
    procedure ContextTreeGetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure CollapseBtnClick(Sender: TObject);
    procedure ExpandBtnClick(Sender: TObject);
    procedure TreeFindSur1BtnClick(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure InsertMarkBtnClick(Sender: TObject);
    procedure MarkListDblClick(Sender: TObject);
    procedure DeleteMarkBtnClick(Sender: TObject);
    procedure MoveUpBtnClick(Sender: TObject);
    procedure MoveDownBtnClick(Sender: TObject);
    procedure MarkListDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure MarkListSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure OpenBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure SaveAsBtnClick(Sender: TObject);
    procedure MarkListGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure MarkListSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure MarkListClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionsDlg: TOptionsDlg;

procedure DoOptionsDlg;

procedure InitalizeBookMarks;

implementation

uses MPEGPlayer, FFBookMarks;

{$R *.dfm}

var MarkFilename: string;

procedure InitalizeBookMarks;
begin
MarkFilename:='';
SetLength(BookMarks,0);
OptionsDlg.MarkList.Invalidate;
end;

procedure TOptionsDlg.CancelBtnClick(Sender: TObject);
begin
Close;
end;


procedure DoOptionsDlg;
begin
OptionsDlg.Show;
end;

procedure TOptionsDlg.SetBtnClick(Sender: TObject);
begin
MSSpin.Value:=MPegPlayer.FFForm.FPlayer.Position;
end;



procedure TOptionsDlg.MarkListDblClick(Sender: TObject);
var Inx: integer;
begin
Inx:=MarkList.Row-1;
if (Inx<0) or (Inx>High(BookMarks)) then exit;
FFForm.FPlayer.Seek(BookMarks[Inx].MarkTime);
end;






procedure TOptionsDlg.TimeSpinChange(Sender: TObject);
var Inx: integer;
begin
MSSpin.NoEventValue:=Round(TimeSpin.Degrees * 3600 * 1000);
Inx:=MarkList.Row-1;
if (Inx<0) or (Inx>High(BookMarks)) then exit;
BookMarks[Inx].MarkTime:=Round(MSSpin.Value);
MarkList.Invalidate;
end;

procedure TOptionsDlg.MSSpinChange(Sender: TObject);
var Inx: integer;
begin
TimeSpin.NoEventValue:=MSSpin.Value / (3600 * 1000);
Inx:=MarkList.Row-1;
if (Inx<0) or (Inx>High(BookMarks)) then exit;
BookMarks[Inx].MarkTime:=Round(MSSpin.Value);
MarkList.Invalidate;
end;

procedure TOptionsDlg.ShowBtnClick(Sender: TObject);
begin
FFForm.FPlayer.DisplayFileFormat(ContextTree);
end;

procedure TOptionsDlg.ContextTreeGetImageIndex(Sender: TObject;
  Node: TTreeNode);
begin
if Node.HasChildren then
	begin
	if Node.Expanded then Node.ImageIndex:=1
	else Node.ImageIndex:=0;
	end
else Node.ImageIndex:=2;
end;

procedure TOptionsDlg.CollapseBtnClick(Sender: TObject);
begin
ContextTree.FullCollapse;
end;


procedure TOptionsDlg.ExpandBtnClick(Sender: TObject);
begin
ContextTree.FullExpand;
end;

procedure TOptionsDlg.TreeFindSur1BtnClick(Sender: TObject);
begin
FindDialog1.Execute;
end;



procedure TOptionsDlg.FindDialog1Find(Sender: TObject);
var Node: TTreeNode;
var Exact,Down: boolean;


	procedure ExpandWholeBranch(Node: TTreeNode);
	{Expand whole branch up to top}
	begin
	if Node<>nil then
		begin
		ExpandWholeBranch(Node.Parent);
		Node.Expand(False);
		end;
	end;


	procedure SelectAndShow(Node: TTreeNode);
	{Select and show outline item}
	begin
	ExpandWholeBranch(Node);
	ContextTree.Selected:=Node;
	ContextTree.SetFocus;
	end;


begin
with ContextTree,FindDialog1 do
 begin
 if Items.Count<1 then exit;
 if Selected=nil then Selected:=Items[0];
 Exact:=(Options*[frWholeWord])=[frWholeWord];
 Down:=(Options*[frDown])=[frDown];
 if Down then Node:=Selected.GetNext
 else Node:=Selected.GetPrev;
 while Node<>nil do
	begin
	if Exact then
		begin
		if ExactCompare(FindText,Node.Text) then
			begin
			SelectAndShow(Node);
			Exit;
			end;
		end
	else if PosWildCard(FindText,Node.Text,'?')<>0 then
		begin
		SelectAndShow(Node);
		Exit;
		end;
	if Down then Node:=Node.GetNext
	else Node:=Node.GetPrev;
 	end;
 end;
MessageDlg('Text not found', mtInformation, [mbOK], 0);
end;





procedure TOptionsDlg.InsertMarkBtnClick(Sender: TObject);
var MS: int64;
begin
MS:=MPegPlayer.FFForm.FPlayer.Position;
AddBookMark('Test-'+IntToStr(Length(BookMarks)),MS);
if Length(BookMarks)<20 then MarkList.RowCount:=20
else MarkList.RowCount:=Length(BookMarks)+1;
MarkList.Invalidate;
end;



procedure TOptionsDlg.DeleteMarkBtnClick(Sender: TObject);
var Inx: integer;
begin
if Length(BookMarks)<1 then exit;
Inx:=MarkList.Row-1;
if (Inx<0) or (Inx>High(BookMarks)) then exit;
if DeleteBookMark(Inx) then
 if Inx>0 then MarkList.Row:=Inx
 else MarkList.Row:=1;
MarkList.Invalidate;
end;



procedure TOptionsDlg.MoveUpBtnClick(Sender: TObject);
var Inx: integer;
begin
if Length(BookMarks)<1 then exit;
Inx:=MarkList.Row-1;
if MoveBookMarkUp(Inx) then MarkList.Row:=MarkList.Row-1;
MarkList.Invalidate;
end;



procedure TOptionsDlg.MoveDownBtnClick(Sender: TObject);
var Inx: integer;
begin
if Length(BookMarks)<1 then exit;
Inx:=MarkList.Row-1;
if MoveBookMarkDown(Inx) then
	MarkList.Row:=MarkList.Row+1;
MarkList.Invalidate;
end;


procedure TOptionsDlg.MarkListDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var S: string;
var Inx: integer;
var BM: TBookMark;
begin
if ARow=0 then
	begin
	case ACol of                            
	 0: OwnerDrawItem(MarkList.Canvas,'#',Rect);
	 1: OwnerDrawItem(MarkList.Canvas,'Name',Rect);
	 2: OwnerDrawItem(MarkList.Canvas,'mSec',Rect);
	 3: OwnerDrawItem(MarkList.Canvas,'Time',Rect);
	 end
	end
else
	begin
	Inx:=ARow-1;
	if (Inx<0) or (Inx>High(BookMarks)) then exit;
	BM:=BookMarks[Inx];
	S:=HourMinuteSecStr(BM.MarkTime / (1000 * 60 * 60), False,False, 1);
	case ACol of
	 0: OwnerDrawInteger(MarkList.Canvas,ARow,Rect);
	 1: OwnerDrawItem(MarkList.Canvas,BM.Name,Rect);
	 2: OwnerDrawInteger(MarkList.Canvas,BM.MarkTime,Rect);
	 3: OwnerDrawItem(MarkList.Canvas,S,Rect);
	 end;
	end;
end;

var SelectingCell: boolean;


procedure TOptionsDlg.MarkListSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var Inx: integer;
begin
if SelectingCell then exit;
SelectingCell:=True;
try
Inx:=ARow - 1;
CanSelect:=Inx<=Length(BookMarks);
if not CanSelect then MarkList.Options:=MarkList.Options - [goRangeSelect]
else MarkList.Options:=MarkList.Options + [goRangeSelect];
if (ACol=1) and (Inx<=Length(BookMarks)) and (MarkList.Row=ARow) and (MarkList.Col=ACol) then
	begin
	MarkList.Options:=MarkList.Options + [goEditing];
	MarkList.Options:=MarkList.Options - [goRowSelect];
	MarkList.EditorMode:=True;
	end
else
	begin
	MarkList.Options:=MarkList.Options - [goEditing];
	MarkList.Options:=MarkList.Options + [goRowSelect];
	MarkList.EditorMode:=False;
	end;
finally SelectingCell:=False; end;
end;


procedure TOptionsDlg.OpenBtnClick(Sender: TObject);
begin
if OpenDialog1.Execute then
	begin
	MarkFilename:=OpenDialog1.Filename;
	LoadBookMarkData(MarkFileName);
	MarkList.Invalidate;
	end;
end;

procedure TOptionsDlg.SaveBtnClick(Sender: TObject);
begin
if MarkFilename='' then SaveAsBtnClick(Sender)
else SaveBookMarkData(MarkFileName);
end;

procedure TOptionsDlg.SaveAsBtnClick(Sender: TObject);
begin
if SaveDialog1.Execute then
	begin
	MarkFilename:=SaveDialog1.Filename;
	SaveBookMarkData(MarkFileName);
	end;
end;

procedure TOptionsDlg.MarkListGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
var Inx: integer;
begin
Inx:=ARow-1;
if (Inx<0) or (Inx>High(BookMarks)) then exit;
Value:=BookMarks[Inx].Name;
end;


procedure TOptionsDlg.MarkListSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var Inx: integer;
begin
Inx:=ARow-1;
if (Inx<0) or (Inx>High(BookMarks)) then exit;
BookMarks[Inx].Name:=Value;
end;


procedure TOptionsDlg.MarkListClick(Sender: TObject);
var Inx: integer;
begin
Inx:=MarkList.Row-1;
if (Inx<0) or (Inx>High(BookMarks)) then exit;
MSSpin.Value:=BookMarks[Inx].MarkTime;
end;

end.
