unit MPEGPlayer;

interface

uses
 Windows,Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
 ExtCtrls, Buttons, ActnList, ComCtrls, DSupport, FFMPEGObject, paintpan, Autobttn, SpinButtons,
  intspin,Clipbrd, Gauges, SuperGauge, Menus, PlayerBar, Reopen,
  FancyButton, Realspin;

 { TFFForm }

type TFFForm = class(TForm)
    Timer1: TTimer;
    Panel9: TPanel;
   ProgGauge: TSuperGauge;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    Open1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Options1: TMenuItem;
    Options2: TMenuItem;
    ReopenMenu: TReopenMenu;
    Reopen1: TMenuItem;
    Panel2: TPanel;
    PlayerBar1: TPlayerBar;
    Panel1: TPanel;
    OpenDialog1: TOpenDialog;
    MuteBtn: TFancySpeedBtn;
    TimeBtn: TFancySpeedBtn;
    N1: TMenuItem;
    Panel10: TPanel;
    StatusDis: TPanel;
    Streams1: TMenuItem;
  procedure eUrlChange(Sender: TObject);
  procedure MuteBtnClick(Sender: TObject);
  procedure TimeBtnClick(Sender: TObject);
  procedure FormCreate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
    procedure ProgGaugeGetText(Sender: TObject; var Text: String);
    procedure ProgGaugeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Open1Click(Sender: TObject);
    function PlayerBar1Command(Command: TPlayerCommand): boolean;
    procedure Options2Click(Sender: TObject);
    procedure ReopenMenuMenuClick(Sender: TObject; Path: String);
    procedure FormActivate(Sender: TObject);
    procedure Streams1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
 private
  procedure UpdateProgress(sender:TObject);
  procedure HandleEOF(sender: TObject; var handled: boolean);
  procedure HandlePlayStart(Sender: TObject);
 public
  FPlayer: TFFMPegPlayer;
 end;

var
 FFForm: TFFForm;

const IniFilename = 'FFMPeg.ini';

procedure OpenMedia(MediaName: string);
function OpenDelphiStream(MS: TStream): boolean;


implementation

uses FFOptions, FFStreamsDlg;

{$R *.dfm}

var FirstActivate: boolean;

{ TForm1 }

const ProgramName = 'Video Player';

procedure TFFForm.eUrlChange(Sender: TObject);
begin
FPlayer.Stop(False);
end;



procedure TFFForm.MuteBtnClick(Sender: TObject);
begin
FPlayer.Mute:=MuteBtn.Down;
end;



procedure TFFForm.TimeBtnClick(Sender: TObject);
begin
FPlayer.ShowTimes:=TimeBtn.Down;
end;


procedure TFFForm.UpdateProgress(sender: TObject);
begin
if FPlayer.Duration<0 then
	begin
	ProgGauge.MaxValue:=100;
	ProgGauge.Progress:=0;
	end
else
	begin
	ProgGauge.MaxValue:=FPlayer.Duration+1;
	ProgGauge.Progress:=FPlayer.Position+1;
	end;
ProgGauge.Refresh;
if OptionsDlg.TrackVideoChk.Checked then
   OptionsDlg.MSSpin.Value:=FPlayer.Position;
OptionsDlg.QueueDeptDis.Text:=IntToStr(FPlayer.MaxDepth);
OptionsDlg.FilenameDis.Text:=FPlayer.Url;
end;



procedure LogAVEvent(S: string);
begin
//FFForm.LogMemo.Lines.Add(S);
end;


procedure TFFForm.FormCreate(Sender: TObject);
begin
FPlayer:=TFFMPegPlayer.Create(self);
FPlayer.Parent:=self;
FPlayer.OnProgress:=UpdateProgress;
FPlayer.OnEof:=HandleEof;
FPlayer.OnPlay:=HandlePlayStart;
FPlayer.Align:=alClient;
ReopenMenu.LoadSubMenu;
PlayerBar1.PlayerState:=psNoFile;
Caption:=ProgramName;
FirstActivate:=True;
end;



procedure TFFForm.FormActivate(Sender: TObject);
begin
if FirstActivate then
	begin
	InitalizeBookMarks;
	end;
FirstActivate:=False;
end;



procedure TFFForm.FormDestroy(Sender: TObject);
begin
ReopenMenu.SaveSubMenu;
FPlayer.Free;
end;


procedure TFFForm.ProgGaugeGetText(Sender: TObject; var Text: String);
var D,P: int64;
var S: string;
begin
P:=FPlayer.Position;
D:=FPlayer.Duration;
if ((d>=0) and (P>=0)) or
   not FPlayer.Playing then S:=GetTimeString(P)+' / '+ GetTimeString(D)
else S:=FormatDateTime('hh:nn:ss',now);
Text:=S+' ('+Text+')';
end;



procedure TFFForm.ProgGaugeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var NewPos: double;
var D: Int64;
begin
D:=FPlayer.Duration;
NewPos:=(X / ProgGauge.width) * D;
FPlayer.Seek(Round(NewPos));
end;

procedure OpenMedia(MediaName: string);
begin
FFForm.StatusDis.Caption:='';
FFForm.FPlayer.Stop(False);
FFForm.FPlayer.Url:=trim(MediaName);
FFForm.PlayerBar1.PlayerState:=psStopped;
FFForm.Caption:=ProgramName+' - '+ExtractFilename(MediaName);
InitalizeBookMarks;
end;


procedure OpenFile(Filename: string);
var Ext: string;
begin
OpenMedia(Filename);
if FileExists(Filename) then ChangeDefaultDir(Filename);
Ext:=LowerCase(ExtractFileExt(Filename));
Ext:=RemoveChars(Ext,' ');
if Ext<>'.mem' then
  FFForm.ReopenMenu.AddMenuItem(Filename);
FFForm.ReopenMenu.SaveSubMenu;
end;


function OpenDelphiStream(MS: TStream): boolean;
begin
Result:=True;
FFForm.FPlayer.Stop(False);
FFForm.PlayerBar1.PlayerState:=psStopped;
FFForm.StatusDis.Caption:='';
FFForm.Caption:=ProgramName+' - Memory Stream';
FFForm.FPlayer.Stream:=MS;
InitalizeBookMarks;
FFForm.Show;
end;


procedure TFFForm.ReopenMenuMenuClick(Sender: TObject; Path: String);
begin
OpenFile(Path);
end;

procedure TFFForm.Open1Click(Sender: TObject);
begin
if OpenDialog1.Execute then
	begin
	OpenFile(OpenDialog1.Filename);
	end;
end;


function TFFForm.PlayerBar1Command(Command: TPlayerCommand): boolean;
begin
Result:=True;
try
case Command of
 pcRewind: FPlayer.Seek(0);
 pcStepBack: FPlayer.Seek(FPlayer.Position-1000);
 pcPlay:
	begin
        StatusDis.Caption:='';
	if FPlayer.Play then OptionsDlg.InfoMemo.Text:=FPlayer.FileFormat
	else
		begin
		StatusDis.Caption:=FPlayer.LastErrorString;
		PlayerBar1.PlayerState:=psNoFile;
		Result:=False;
		end;
	end;
 pcPause: FPlayer.Pause;
 pcResume: FPlayer.Resume;
 pcStop: FPlayer.Stop(False);
 pcStepForward: FPlayer.Seek(FPlayer.Position+1000);
 pcEnd: FPlayer.Seek(FPlayer.Duration-FPlayer.Duration div 25);
 end;
except
 PlayerBar1.PlayerState:=psStopped;
 end;
end;


procedure TFFForm.Options2Click(Sender: TObject);
begin
DoOptionsDlg;
end;




procedure TFFForm.HandlePlayStart(Sender: TObject);
begin
OptionsDlg.MSSpin.MaxValue:=FPlayer.Duration;
OptionsDlg.TimeSpin.MaxValue:=OptionsDlg.MSSpin.MaxValue / (3600 * 1000);
end;

procedure TFFForm.HandleEOF(sender: TObject; var handled: boolean);
begin
PlayerBar1.PlayerState:=psStopped;
end;


procedure TFFForm.Streams1Click(Sender: TObject);
begin
ShowStreamsDlg;
end;



procedure TFFForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FPlayer.Stop(False);
end;

end.

