unit MySpaceLib;

interface

uses Windows,Messages,SysUtils,ShDocVw,WinInet,Classes,MSHTML,HugeArry,Hash,DSupport, SBObjects;

var CaptchaCount: integer;


procedure NavigateTo(URL: string);

procedure GetMyTokens(Dispatch: IDispatch; Tokens: TStringList);
procedure GetFriendIDs(Dispatch: IDispatch;  FIArray: THugeFriendID; MyID: integer);
function ExtractIDStr(S: string; First,Last: integer): string;
function GetFirstToken(Dispatch: IDispatch): string;
function GetMyFriendID(Browser: TWebBrowser): integer;
procedure GetAllFriendIDs(FA: THugeFriendID; MyID: integer);
procedure MySpaceLogin(EmailAddress,Password: string);
procedure GetFriendRequestIDs(FA: THugeFriendID; MyID: integer);
procedure PostCommentsToAll;
procedure GotoProfile(FriendID: integer; Token: string);
procedure GetBirthdayFriendIDs(FA: THugeFriendID; MyID: integer);
procedure GetCurrentFriendIDs(URL: string; FA: THugeFriendID; MyID: integer);
procedure GotoFriendRequestForm(FriendID: integer; Token: string);
procedure DoAllFriendRequests;

implementation

uses MSHTMLLib, SBMain, SBGlobal, SBUserInterface, SBUserWait, SBSettings;



{------------ Support Routines ----------------------------------------------}

procedure NavigateTo(URL: string);
var Flags: OLEVariant;
begin
Flags:=0;
Form1.WebBrowser1.Navigate(WideString(URL), Flags, Flags, Flags, Flags);
end;


{--------------- Routines To Wait Until Browser is Ready ----------------------}


function WaitForPageReady(TimeOutSec: double): boolean;
var Cnt,I: integer;
const Granularity = 1000;
const SecPerCnt = Granularity / 1000;
begin
DocumentCount:=0;
Result:=True;
Cnt:=Round(TimeOutSec/SecPerCnt);
for I:=1 to Cnt do
	begin
	if AbortOperation then exit;
	if DocumentCount>0 then exit;
	DelayProcessMessages(Granularity);
	Form1.TimeOutDis.Caption:=FloatToStrF((Cnt-I) * SecPerCnt,ffFixed,18,1);
	Form1.TimeOutDis.Update;
	end;
Result:=False;
end;





function WaitForNewPage(TimeOutSec: double): boolean;
begin
Result:=WaitForPageReady(TimeOutSec);
if Result then DisplayStatus('Page Loaded')
else
	begin
	if AbortOperation then DisplayStatus('User Abort')
	else DisplayStatus('Unable to Load Page');
	end;
end;


{-------------------------Routines To Open Various pages ----------------------}

const TokenTag = '&MyToken=';


procedure GotoSpecifiedPage(URL: string; FriendID: integer; Token: string);
begin
NavigateTo(URL+IntToStr(FriendID)+TokenTag+Token);
end;



procedure GotoProfile(FriendID: integer; Token: string);
const ProfileTag = 'http://profile.myspace.com/index.cfm?fuseaction=user.viewprofile&friendid=';
begin
NavigateTo(ProfileTag+IntToStr(FriendID)+TokenTag+Token);
end;



procedure GotoCommentForm(FriendID: integer; Token: string);
const CommentFormTag = 'http://comment.myspace.com/index.cfm?fuseaction=user.viewProfile_commentForm&friendID=';
begin
NavigateTo(CommentFormTag+IntToStr(FriendID)+TokenTag+Token);
end;




procedure GotoFriendRequestForm(FriendID: integer; Token: string);
const RequestFormTag = 'http://messaging.myspace.com/index.cfm?fuseaction=invite.addfriend_verify&friendID=';
begin
NavigateTo(RequestFormTag+IntToStr(FriendID)+TokenTag+Token);
end;


{--------------------Routines For handling Tokens ----------------------------}


function ExtractMyToken(Raw: string): string;
var Inx,I: integer;
const IDTag = 'mytoken';
begin
Result:='';
Inx:=PosNocase(IDTag,Raw);
if Inx>0 then
 for I:=Inx+Length(IDTag)+1 to Length(Raw) do
  if Raw[I] in ['a'..'f','A'..'F','0'..'9','-'] then Result:=Result+Raw[I]
   else break;
end;




procedure GetMyTokens(Dispatch: IDispatch; Tokens: TStringList);
{Get a list of tokens on the page}
var AllLinks: IHTMLElementCollection;
var Link: IHTMLElement;
var I: integer;
var Document: IHTMLDocument2;
var S: string;
begin
Document:=Dispatch as IHTMLDocument2;
AllLinks:= Document.Links;
for I:=0 to AllLinks.length-1 do
	begin
	Link:=AllLinks.Item(I,'') as IHTMLElement;
	S:=ExtractMyToken(Link.ToString);
	if S<>'' then Tokens.Add(Link.title+' '+S);
	end;
end;





function GetFirstToken(Dispatch: IDispatch): string;
{Get a list of tokens on the page}
var AllLinks: IHTMLElementCollection;
var Link: IHTMLElement;
var I: integer;
var Document: IHTMLDocument2;
var S: string;
begin
Result:='';
Document:=Dispatch as IHTMLDocument2;
AllLinks:= Document.Links;
for I:=0 to AllLinks.length-1 do
	begin
	Link:=AllLinks.Item(I,'') as IHTMLElement;
	Result:=ExtractMyToken(Link.ToString);
	if Result<>'' then break;
	end;
end;



{--------------- Access pages by Finding Next Button --------------------------}


var NextPageLink: string;


procedure GotoNextPage;
begin
NavigateTo(NextPageLink);
end;



function HasNextPage(Dispatch: IDispatch): boolean;
var AllLinks: IHTMLElementCollection;
var Link: IHTMLElement;
var I: integer;
var Document: IHTMLDocument2;
begin
Result:=True;
Document:=Dispatch as IHTMLDocument2;
AllLinks:= Document.Links;
for I:=0 to AllLinks.length-1 do
	begin
	Link:=AllLinks.Item(I,'') as IHTMLElement;
	if PosNoCase('next',Link.innerText)>0 then
	if PosNoCase('A',Link.tagName)>0 then
		begin
		NextPageLink:=Link.toString;
		exit;
		end;
	end;
Result:=False;
end;



{---------------------Routines For Handling Friend IDs -----------------------}

function ExtractIDStr(S: string; First,Last: integer): string;
var I: integer;
begin
Result:='';
for I:=First to Last do
 if S[I] in ['0'..'9','-'] then Result:=Result+S[I] else break;
end;


function ExtractFriendID(Raw: string): string;
var Inx,I: integer;
const IDTag = 'FriendID';
begin
Result:='';
Inx:=PosNocase(IDTag,Raw);
if Inx>0 then Result:=ExtractIDStr(Raw,Inx+Length(IDTag)+1,Length(Raw));
end;



procedure GetFriendIDs(Dispatch: IDispatch;  FIArray: THugeFriendID; MyID: integer);
var AllLinks: IHTMLElementCollection;
var Link: IHTMLElement;
var I: integer;
var Document: IHTMLDocument2;
var FI: TFriendID;
var S,LinkStr: string;
begin
Document:=Dispatch as IHTMLDocument2;
AllLinks:= Document.Links;
for I:=0 to AllLinks.length-1 do
	begin
	Link:=AllLinks.Item(I,'') as IHTMLElement;
	LinkStr:=Link.toString;
	S:=ExtractFriendID(LinkStr);
	if (S<>'') and (PosNoCase('WhosOnline',Link.Id)<1) then
		begin
		if Link.title='' then FI.Name:=Link.innerText
		else FI.Name:=Link.title;
		FI.ID:=StrToIntDef(S,0);
		FI.Checked:=True;
		if MyID <> FI.ID then FIArray.Add(FI);
		end;
	end;
end;



function GetMyFriendID(Browser: TWebBrowser): integer;
var Doc: string;
var Inx: integer;
var S: string;
const IDTag = 'MySpace.ClientContext = {"UserId":';
begin
Doc:=GetInnerHTML(Browser);
Inx:=Pos(IDTag,Doc);
if Inx>0 then S:=ExtractIDStr(Doc,Inx+Length(IDTag),Length(Doc));
Result:=StrToIntDef(S,0);
end;


{-----------------------------------------------------------------------------}


function IsServerBusy: boolean;
var S: string;
Const BusyTag = 'Server is too busy';
begin
S:=GetInnerText(Form1.WebBrowser1);
Result:=PosNoCase(BusyTag,S)>0;
end;


procedure ParsePagesForFriendIDs(StartURL: string; FA: THugeFriendID; MyID: integer; IsFullURL: boolean);
var I,C: integer;


	function GetFirstPage: boolean;
	var I: integer;
	begin
	Result:=True;
	for I:=1 to SettingsDlg.RetriesSpin.Value do
		begin
		if IsFullURL then MySpaceLib.NavigateTo(StartURL)
		else GotoSpecifiedPage(StartURL,CurrentFriendID, CurrentToken);
		if WaitForNewPage(SettingsDlg.TimeoutSpin.Value) and not IsServerBusy then exit;
		DisplayStatus('Retrying First Page');
		Form1.WebBrowser1.Stop;
		end;
	Result:=False;
	end;



	function GetNextPage(Inx: integer): boolean;
	var I: integer;
	begin
	Result:=True;
	for I:=1 to SettingsDlg.RetriesSpin.Value do
		begin
		GotoNextPage;
		if WaitForNewPage(SettingsDlg.TimeoutSpin.Value) and not IsServerBusy then
			begin
			StartURL:=Form1.WebBrowser1.LocationURL;
			IsFullURL:=True;
			exit;
			end;
		DisplayStatus('Retry # '+IntToStr(I)+' Of Page - '+IntToStr(Inx));
		if IsServerBusy then GetFirstPage;
		end;
	Result:=False;
	end;


begin
AbortOperation:=False;
I:=1;
DisplayStatus('Loading Page - '+IntToStr(I));
if not GetFirstPage then exit;
while true do
	begin
	if AbortOperation then break;
	GetFriendIDs(Form1.WebBrowser1.Document,FA,MyID);
	Inc(I);
	DisplayStatus('Loading Page - '+IntToStr(I));
	if not HasNextPage(Form1.WebBrowser1.Document) then break;
	if not GetNextPage(I) then break;
	end;
DisplayStatus('Done - '+IntToStr(I)+' Pages Loaded');
end;



{---------------- Get Friend IDs From Friends Pages --------------------------}


procedure GetAllFriendIDs(FA: THugeFriendID; MyID: integer);
const FriendsPageURL ='http://friends.myspace.com/index.cfm?fuseaction=user.viewfriends&friendID=';
begin
ParsePagesForFriendIDs(FriendsPageURL,FA,MyID,False);
end;



{-------------- Handle Birthday Pages ----------------------------------------}




procedure GetBirthdayFriendIDs(FA: THugeFriendID; MyID: integer);
const BirthdayPageURL = 'http://friends.myspace.com/index.cfm?fuseaction=user.birthdays&MyToken=';
begin
ParsePagesForFriendIDs(BirthdayPageURL,FA,MyID,False);
end;



{-------------- Handle Friend Request Pages -----------------------------------}



procedure GetFriendRequestIDs(FA: THugeFriendID; MyID: integer);
const RequestsPageURL = 'http://messaging.myspace.com/index.cfm?fuseaction=mail.friendRequests&MyToken=';
begin
ParsePagesForFriendIDs(RequestsPageURL,FA,MyID,False);
end;



{-------------- Handle Loading IDs from current Pages --------------------------}



procedure GetCurrentFriendIDs(URL: string; FA: THugeFriendID; MyID: integer);
begin
ParsePagesForFriendIDs(URL,FA,MyID,True);
end;


{------------- Handle Login Procedss ------------------------------------------}




procedure MySpaceLogin(EmailAddress,Password: string);
var LoginForm: IHTMLFormElement;
var I: integer;
var EmailFieldName: string;
var PasswordFieldName: string;


	function GetLoginPage: boolean;
	var I: integer;
	begin
	Result:=True;
	for I:=1 to SettingsDlg.RetriesSpin.Value do
		begin
		NavigateTo('http://www.myspace.com');
		if WaitForNewPage(SettingsDlg.TimeoutSpin.Value) and not IsServerBusy then exit;
		DisplayStatus('Retrying Login Page');
		Form1.WebBrowser1.Stop;
		end;
	Result:=False;
	end;


	function GetFieldNames(var EmailField,PassField: string): boolean;
	var Form: IHTMLFormElement;
	var FormList,FieldList: TStringList;
	var I,J: integer;
	begin
	Result:=False;
	FormList:=TStringList.Create;
	FieldList:=TStringList.Create;
	GetAllFormNames(Form1.WebBrowser1.Document,FormList);
	for I:=0 to FormList.Count-1 do
		begin
		Form:=GetFormByName(Form1.WebBrowser1.Document,FormList[I]);
		GetFormFieldNames(Form,FieldList,False);
		for J:=0 to FieldList.Count-1 do
			begin
			if PosNoCase('Email_Textbox',FieldList[J])>0 then EmailField:=FieldList[J];
			if PosNoCase('Password_Textbox',FieldList[J])>0 then PassField:=FieldList[J];
			Result:=(EmailField<>'') and (PassField<>'');
			end;
		end;
	FormList.Free;
	FieldList.Free;
	end;



begin
AbortOperation:=False;
for I:=1 to SettingsDlg.RetriesSpin.Value do
	begin
	if not GetLoginPage then exit;
	LoginForm:=GetFormByName(Form1.WebBrowser1.Document as IHTMLDocument2,'aspnetForm');
	if (LoginForm<>nil) and GetFieldNames(EmailFieldName,PasswordFieldName) then break;
	DisplayStatus('No Login Form - Retrying');
	InternetSetOption(nil, INTERNET_OPTION_END_BROWSER_SESSION, nil, 0);
	end;

SetFieldValue(LoginForm,EmailFieldName,EmailAddress);
SetFieldValue(LoginForm,PasswordFieldName,Password);
LoginForm.submit;
if not WaitForNewPage(SettingsDlg.TimeoutSpin.Value) then exit;

DisplayStatus('Logged In');
CurrentFriendID:=GetMyFriendID(Form1.WebBrowser1);
CurrentToken:=GetFirstToken(Form1.WebBrowser1.Document);
UpdateStateDisplay;
end;



{---------------- Routine for handling submitting comments --------------------}



procedure SubmitComment(Comment: string);
var CommentForm: IHTMLFormElement;

const CommentFieldName = 'ctl00$ctl00$cpMain$UserWriteCommentsControl$commentTextBox';
const SubmitButton = 'ctl00$ctl00$cpMain$UserWriteCommentsControl$postcommentImageButton';
begin
CommentForm:=GetFormByName(Form1.WebBrowser1.Document as IHTMLDocument2,'aspnetForm');
SetFieldValue(CommentForm,CommentFieldName,Comment);
SubmitByElementName(Form1.WebBrowser1.Document,SubmitButton);
end;




function IsCommentCaptchaForm: boolean;
const CaptchaBoxFieldName = 'ctl00$ctl00$cpMain$UserWriteCommentsControl$captcha$captchaResponseTextBox';
var E: IHTMLElement;
begin
E:=GetElementByName(Form1.WebBrowser1.Document, CaptchaBoxFieldName);
Result:=E<>nil;
end;



function IsNoHTMLForm: boolean;
var S: string;
const NoHTMLTag = 'Note: This user disables HTML comments';
begin
S:=GetInnerText(Form1.WebBrowser1);
Result:=PosNoCase(NoHTMLTag,S)>0;
end;



function ConfirmComment: boolean;
var ConfirmForm: IHTMLFormElement;
const ConfirmButton = 'ctl00$ctl00$cpMain$UserWriteCommentsControl$ConfirmPostButton';
begin
ConfirmForm:=GetFormByName(Form1.WebBrowser1.Document as IHTMLDocument2,'aspnetForm');
Result:=SubmitByElementName(Form1.WebBrowser1.Document,ConfirmButton);
end;




{-----------------------------------------------------------------------------}

type TCommentStatus = (csCaptchaPosted,csCaptchaSkipped,csNoHTMLPosted,csNoHTMLSkipped,csPageFailure,csPosted,csAlreadyFriend);


var NoHTMLFlag: boolean;
var CaptchaFlag: boolean;
var SkippedFlag: boolean;
var PageFailure: boolean;
var SubmitFailure: boolean;
var AlreadyFriend: boolean;
var MustKnow: boolean;

procedure ClearFlags;
begin
NoHTMLFlag:=False;
CaptchaFlag:=False;
SkippedFlag:=False;
PageFailure:=False;
SubmitFailure:=False;
AlreadyFriend:=False;
MustKnow:=False;
end;


function GetSpecifiedComment(var Comment: String): boolean;
begin
Result:=False;
Comment:='';
if IsNoHTMLForm then
	begin
	NoHTMLFlag:=True;
	case SettingsDlg.NoHTMLRadio.ItemIndex of
	 0: Comment:=Form1.AltCommentMemo.Text;
	 1: exit;
	 2: Comment:=Form1.HTMLCommentMemo.Text;
	 end;
	end
else Comment:=Form1.HTMLCommentMemo.Text;
Result:=True;
end;




function HandleCaptchaForm: boolean;
const CaptchaMessage = 'Go to browser and enter Proper Captcha Code. Press OK when you''re done';
begin
Result:=True;
CaptchaFlag:=True;
if SettingsDlg.CaptchaRadio.ItemIndex=0 then
	begin
	if SettingsDlg.ScrollBottomChk.Checked then ScrollBrowser(Form1.WebBrowser1,0,4000);
	ShowUserWaitDlg('Captcha Wait',CaptchaMessage)
	end
else Result:=False;
end;




function PostOneComment(FriendID: TFriendID): boolean;
var Comment: string;


	function FindCommentPage: boolean;
	var I: integer;
	begin
	Result:=True;
	for I:=1 to SettingsDlg.RetriesSpin.Value do
		begin
		GotoCommentForm(FriendID.ID,CurrentToken);
		if WaitForNewPage(SettingsDlg.TimeoutSpin.Value) and not IsServerBusy then exit;
		DisplayStatus('Retrying Page: '+IntToStr(I));
		Form1.WebBrowser1.Stop;
		end;
	Result:=False;
	end;


	function SubmitAndWait: boolean;
	var I: integer;
	begin
	Result:=True;
	for I:=1 to SettingsDlg.RetriesSpin.Value do
		begin
		SubmitComment(Comment);
		if WaitForNewPage(SettingsDlg.TimeoutSpin.Value) and not IsServerBusy then exit;
		DisplayStatus('Resubmitting Comment: '+IntToStr(I));
		if not FindCommentPage then exit;
		end;
	Result:=False;
	end;


	function ConfirmCommentAndWait: boolean;
	var I: integer;
	begin
	Result:=True;
	for I:=1 to SettingsDlg.RetriesSpin.Value do
		begin
		if not ConfirmComment then
			begin
			Result:=False;
			exit;
			end;
		if WaitForNewPage(SettingsDlg.TimeoutSpin.Value) and not IsServerBusy then exit;
		DisplayStatus('Resubmitting Comment: '+IntToStr(I));
		if not SubmitAndWait then exit;
		end;
	Result:=False;
	end;


begin
Result:=False;
ClearFlags;
if not FindCommentPage then
	begin
	PageFailure:=True;
	exit;
	end;

if not GetSpecifiedComment(Comment) then
	begin
	SkippedFlag:=True;
	exit;
	end;
if not SubmitAndWait then
	begin
	PageFailure:=True;
	exit;
	end;

if IsCommentCaptchaForm then
	begin
	Inc(CaptchaCount);

	SkippedFlag:=not HandleCaptchaForm;
	end
else if not ConfirmCommentAndWait then
	begin
	SubmitFailure:=True;
	exit;
	end;
Result:=not SkippedFlag;
end;




procedure LogCommentItem(Cnt: integer; FID: TFriendID);
var S: string;
var P: double;
begin
S:=IntToStr(Cnt)+' - '+FID.Name+' '+IntToStr(FID.ID);
Form1.CommentLog.Lines.Add(S);

S:='   ';
if NoHTMLFlag then S:=S+' No HTML';
if CaptchaFlag then S:=S+' Captcha';
if SkippedFlag then S:=S+' Skipped';
if PageFailure then S:=S+' Page Failure';
if SubmitFailure then S:=S+' Submit Failure';

Form1.CommentLog.Lines.Add(S);
SendMessage(Form1.CommentLog.handle, EM_SCROLLCARET,0,0);
P:=(CaptchaCount/(Cnt+1))*100;
Form1.CaptchStatusDis.Caption:=IntToStr(CaptchaCount)+'/'+IntToStr(Cnt)+'  '+FloatToStrF(P,ffFixed,18,1)+'%';
end;




procedure PostCommentsToAll;
var I: integer;
var FID: TFriendID;
var Posted: boolean;
begin
CaptchaCount:=0;
AbortOperation:=False;
for I:=0 to Form1.FriendList.Items.Count-1 do
 if Form1.FriendList.Items[I].Checked then
	begin
	if AbortOperation then exit;
	Form1.FriendList.Items[I].MakeVisible(False);
	FID:=TFriendID(Form1.FriendList.Items[I].Data^);
	Posted:=PostOneComment(FID);
	LogCommentItem(I,FID);
	if SettingsDlg.UncheckChk.Checked and Posted then Form1.FriendList.Items[I].Checked:=False;
	end;
end;

{-----------------------------------------------------------------------------}

const FriendNoteFieldName = 'ctl00$ctl00$cpMain$NoteToFriend$Note';



function IsFriendRequestCaptchaForm: boolean;
const CaptchaBoxFieldName = 'ctl00$ctl00$cpMain$captcha$reCaptchaChallengeField';
var E: IHTMLElement;
begin
E:=GetElementByName(Form1.WebBrowser1.Document, CaptchaBoxFieldName);
Result:=E<>nil;
end;



procedure SubmitFriendRequest(Comment: string; var Captcha: boolean);
var CommentForm: IHTMLFormElement;
const SubmitButton = 'ctl00$ctl00$cpMain$btnAddToFriends';
begin
CommentForm:=GetFormByName(Form1.WebBrowser1.Document as IHTMLDocument2,'aspnetForm');
SetFieldValue(CommentForm,FriendNoteFieldName,Comment);
Captcha:=IsFriendRequestCaptchaForm;
if Captcha then HandleCaptchaForm
else SubmitByElementName(Form1.WebBrowser1.Document,SubmitButton);
end;



function IsAlreadyFriend: boolean;
const CaptchaBoxFieldName = 'ctl00$ctl00$cpMain$captcha$reCaptchaChallengeField';
var E: IHTMLElement;
begin
E:=GetElementByName(Form1.WebBrowser1.Document, FriendNoteFieldName);
Result:=E=nil;
end;




function IsRequiresYouKnow: boolean;
const CaptchaBoxFieldName = 'ctl00$ctl00$cpMain$PrivacyRequired$txtEmail';
var E: IHTMLElement;
begin
E:=GetElementByName(Form1.WebBrowser1.Document, FriendNoteFieldName);
Result:=E=nil;
end;



procedure LogFriendRequestItem(Cnt: integer; FID: TFriendID);
var S: string;
var P: double;
begin
S:=IntToStr(Cnt)+' - '+FID.Name+' '+IntToStr(FID.ID);
Form1.FriendRequestMemo.Lines.Add(S);

S:='   ';
if NoHTMLFlag then S:=S+' No HTML';
if CaptchaFlag then S:=S+' Captcha';
if SkippedFlag then S:=S+' Skipped';
if PageFailure then S:=S+' Page Failure';
if SubmitFailure then S:=S+' Submit Failure';
if AlreadyFriend then S:=S+' Already Friend';
if MustKnow then S:=S+' Requires You Know Them';

Form1.FriendRequestMemo.Lines.Add(S);
SendMessage(Form1.FriendRequestMemo.handle, EM_SCROLLCARET,0,0);
P:=(CaptchaCount/(Cnt+1))*100;
Form1.CaptchStatusDis2.Caption:=IntToStr(CaptchaCount)+'/'+IntToStr(Cnt)+'  '+FloatToStrF(P,ffFixed,18,1)+'%';
end;


function PostOneFriendRequest(FriendID: TFriendID): boolean;
var Comment: string;


	function FindRequestPage: boolean;
	var I: integer;
	begin
	Result:=True;
	for I:=1 to SettingsDlg.RetriesSpin.Value do
		begin
		GotoFriendRequestForm(FriendID.ID,CurrentToken);
		if WaitForNewPage(SettingsDlg.TimeoutSpin.Value) and not IsServerBusy then exit;
		DisplayStatus('Retrying Page: '+IntToStr(I));
		Form1.WebBrowser1.Stop;
		end;
	Result:=False;
	end;


	function SubmitAndWait: boolean;
	var I: integer;
	var Captcha: boolean;
	begin
	Result:=True;
	for I:=1 to SettingsDlg.RetriesSpin.Value do
		begin
		SubmitFriendRequest(Comment,Captcha);
		if Captcha then
			begin
			Inc(CaptchaCount);
			exit;
			end;
		if WaitForNewPage(SettingsDlg.TimeoutSpin.Value) and not IsServerBusy then exit;
		DisplayStatus('Resubmitting Comment: '+IntToStr(I));
		if not FindRequestPage then exit;
		end;
	Result:=False;
	end;


begin
Result:=False;
ClearFlags;
if not FindRequestPage then
	begin
	PageFailure:=True;
	exit;
	end;

if IsAlreadyFriend then
	begin
	AlreadyFriend:=True;
	exit;
	end;
if IsRequiresYouKnow then
	begin
	MustKnow:=True;
	exit;
	end;

Comment:=Form1.FriendNoteMemo.Text;
if not SubmitAndWait then
	begin
	PageFailure:=True;
	exit;
	end;

Result:=not SkippedFlag;
end;





procedure DoAllFriendRequests;
var I: integer;
var FID: TFriendID;
var Posted: boolean;
begin
CaptchaCount:=0;
AbortOperation:=False;
for I:=0 to Form1.FriendList.Items.Count-1 do
 if Form1.FriendList.Items[I].Checked then
	begin
	if AbortOperation then exit;
	Form1.FriendList.Items[I].MakeVisible(False);
	FID:=TFriendID(Form1.FriendList.Items[I].Data^);
	Posted:=PostOneFriendRequest(FID);
	LogFriendRequestItem(I,FID);
	if SettingsDlg.UncheckChk.Checked and Posted then Form1.FriendList.Items[I].Checked:=False;
	end;
end;


end.
