unit GLXFileReader;

interface


uses Windows,Classes,SysUtils,Graphics,Vector,HugeArry,GLViewer,GLMesh,GL3DFigures,GLXFileGlobal;


var FileInfo: TXFileInfo;


procedure ReadXFile(FileName: string; Viewer: TGLViewer; ProgressProc: TProgressProcedure; NewMeshes: boolean);
procedure ReadXStream(Stream: TStream; Viewer: TGLViewer; ProgressProc: TProgressProcedure; NewMeshes: boolean);

implementation

uses StreamLib, GLXFileTextReader, GLXFileBinToText;



procedure ReadBinaryXStream(Stream: TStream; Viewer: TGLViewer; ProgInfo: TProgressInfo; NewMeshes: boolean);
{Convert binary file to text then read it into the specified GLViewer}
var XText: string;
var MS: TMemoryStream;
begin
MS:=TMemoryStream.Create;
try
ProgInfo.Multiplier:=50;
ProgInfo.Offset:=0;
BinToTextXStream(Stream,XText,ProgInfo);
MS.Write(XText[1],Length(XText)+1);
ProgInfo.Offset:=50;
ParseTextXFile(MS,Viewer,ProgInfo,NewMeshes);
finally MS.Free; end;
end;


procedure ReadXStream(Stream: TStream; Viewer: TGLViewer; ProgressProc: TProgressProcedure; NewMeshes: boolean);
var ProgInfo: TProgressInfo;
begin
ProgInfo.Proc:=ProgressProc;
ProgInfo.Multiplier:=100;
ProgInfo.Offset:=0;
if not ReadXFileHeader(Stream,FileInfo) then raise Exception.Create('Invalid File');
case FileInfo.FileType of
 ffBinary: ReadBinaryXStream(Stream,Viewer,ProgInfo,NewMeshes);
 ffText: ParseTextXFile(Stream,Viewer,ProgInfo,NewMeshes);
 else raise Exception.Create('File Type Unsupported: '+XFileFormatToStr(FileInfo.FileType));
 end;
end;



procedure ReadXFile(FileName: string; Viewer: TGLViewer; ProgressProc: TProgressProcedure; NewMeshes: boolean);
{Read X  file }
var Stream: TMemoryStream;
begin
Stream := TMemoryStream.Create;
Stream.LoadFromFile(Filename);
try
ReadXStream(Stream,Viewer,ProgressProc,NewMeshes);
finally Stream.Free; end;
end;



end.
