unit TreeSorter;

interface

uses Windows,SysUtils,ComCtrls,DSupport;

{ custom sort styles }

type TCustomSortStyle = (cssAlphaNum, cssNumeric, cssDateTime, cssFloat);

var  LvSortStyle: TCustomSortStyle;      { variable to hold the sort style }
var  LvSortOrder: array[0..20] of Boolean; { High[LvSortOrder] = Number of Lv Columns }

function CustomSortProc(Item1, Item2: TListItem; SortColumn: Integer): Integer; stdcall;

implementation



  { Helper functions }

function IsValidNumber(AString : string; var AInteger : int64): Boolean;
var  Code: Integer;
begin
Val(AString, AInteger, Code);
Result := (Code = 0);
end;



function IsValidDate(AString : string; var ADateTime : TDateTime): Boolean;
begin
Result := True;
try
ADateTime := StrToDateTime(AString);
except
 ADateTime := 0;
 Result := False;
 end;
end;



function IsValidFloat(AString : string; var AFloat : extended): Boolean;
begin
Result:=TextToFloat(PChar(AString), AFloat, fvExtended);
if not Result then AFloat:=0;
end;




function CompareDates(dt1, dt2: TDateTime): Integer;
begin
if (dt1 > dt2) then Result := 1
else if (dt1 = dt2) then Result := 0
else Result := -1;
end;



function CompareFloats(d1, d2: double): Integer;
begin
if (d1 > d2) then Result := 1
else if (d1 = d2) then Result := 0
else Result := -1;
end;



function CompareNumeric(AInt1, AInt2: int64): Integer;
begin
if AInt1 > AInt2 then Result := 1
else if AInt1 = AInt2 then Result := 0
else Result := -1;
end;


function CustomSortProc(Item1, Item2: TListItem; SortColumn: Integer): Integer; stdcall;
var s1, s2: string;
var i1, i2: int64;
var r1, r2: Boolean;
var d1, d2: TDateTime;
var f1, f2: extended;
begin
Result := 0;

if (Item1 = nil) or (Item2 = nil) then Exit;

case SortColumn of
 -1 :
 	{ Compare Captions }
 	begin
 	s1 := Item1.Caption;
 	s2 := Item2.Caption;
 	end;
else { Compare Subitems }
	begin
	s1 := '';
	s2 := '';
	{ Check Range }
	if (SortColumn < Item1.SubItems.Count) then s1 := Item1.SubItems[SortColumn];
	if (SortColumn < Item2.SubItems.Count) then s2 := Item2.SubItems[SortColumn]
	end;
end;

  { Sort styles }

case LvSortStyle of
 cssAlphaNum: Result := lstrcmp(PChar(s1), PChar(s2));
 cssNumeric:
	begin
	r1 := IsValidNumber(s1, i1);
	r2 := IsValidNumber(s2, i2);
	Result := ord(r1 or r2);
	if Result <> 0 then Result := CompareNumeric(i2, i1);
	end;
 cssDateTime :
	begin
	r1 := IsValidDate(s1, d1);
	r2 := IsValidDate(s2, d2);
	Result := ord(r1 or r2);
	if Result <> 0 then Result := CompareDates(d1, d2);
	end;
 cssFloat :
	begin
	f1 := GetNumberValue(s1);
	f2 := GetNumberValue(s2);
	Result := CompareFloats(f1, f2);
	end;
 end;

{ Sort direction }
if LvSortOrder[SortColumn + 1] then Result := - Result;
end;




end.
 