unit SizeAdjust;

interface

uses
  Dialogs,
  SysUtils, WinTypes, WinProcs, Messages, 
  Classes;

type
  TSizeAdjuster = class(TComponent)
  private
    { Private declarations }
    FDesignPixPerIn: integer;
    FRunPixPerIn: integer;
    FAdjustFlag: boolean;
  protected
    { Protected declarations }

  public
    { Public declarations }
    constructor 
      Create(AOwner: TComponent); override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

uses  Forms, Controls;


procedure Register;
begin
RegisterComponents('Fountain', [TSizeAdjuster]);
end;


constructor TSizeAdjuster.Create(AOwner: TComponent);
var Form: TForm;
begin
inherited Create(AOwner);
if (AOwner is TForm) then
	begin
	Form:=TForm(AOwner);
	FDesignPixPerIn:=Form.PixelsPerInch;
 	FRunPixPerIn:=Screen.PixelsPerInch;
 	FAdjustFlag:=Form.BorderStyle = bsSizeable;
	if FAdjustFlag and (FDesignPixPerIn<>FRunPixPerIn) then
		begin
		Form.Width:=MulDiv(Form.Width,FRunPixPerIn,FDesignPixPerIn);
		Form.Height:=MulDiv(Form.Height,FRunPixPerIn,FDesignPixPerIn);
		end;
	end
else raise Exception.Create('A Form MUST be the owner');
end;

end.
